# Copyright (c) 2000 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

# Some parts of code have been taken from package PyXML-0.6.5 
# Copyright (c) 2000 Fourthought Inc, USA 
# License Agreement and CNRI's notice of copyright, i.e., "Copyright (c)
# Copyright (c) 1991 - 1995, Stichting Mathematisch Centrum Amsterdam,
# Copyright (c) 1998 by Secret Labs AB.   

from narval.lib import *

MOD_XML='''<?xml version="1.0" encoding="ISO-8859-1"?>
<module xmlns:al="%s">''' % AL_NS

XBEL_NS = NO_NS
CHKS_NS = 'http://www.logilab.org/namespaces/CHKS'

#
# Extractor class
#
import copy, re, xmllib
from xml.sax import make_parser
#from xml.sax import saxexts

bookmark = load_extension_module('xbel','bookmark')
ns_parse = load_extension_module('xbel','ns_parse')
lynx_parse = load_extension_module('xbel','lynx_parse') 
# msie_parse=load_extension_module('xbel','msie_parse')

# Convert the Bookmarks file into an xbel file
def parse_bmf_f(args, doc):
    child = args['bmf']
    type = child.getAttributeNS(XBEL_NS,'type')
    url = normalize_url(child.firstChild.data)

    # check the browser type (netscape, lynx, opera ...)
    if type in ('netscape', 'mozilla'):
        try:
            f = urllib.urlopen(url[0])
            ns_handler = ns_parse.NetscapeHandler()
            p = make_parser(['xml.sax.drivers2.drv_sgmlop_html'])
            p.setContentHandler(ns_handler)
            p.parse(f)
            bms = ns_handler.bms
            xbel = bms.dump_xbel(doc)
        except IOError, e:
            print 'HouHou',error(doc, 'No such url %s'%url[0], str(e))
            return {'error': error(doc, 'No such url %s'%url[0], str(e))}
    elif type == 'lynx':
        print 'Warning : Beta version for lynx'
        bms = bookmark.Bookmarks()
        # Determine the owner on Unix platforms
        import os, pwd, glob
        uid = os.getuid()
        t = pwd.getpwuid( uid )
        bms.owner = t[4]
        xbel = doc.createElementNS(XBEL_NS,'xbel')
        glob_pattern = os.path.join(url[0], '*.html')
        file_list = glob.glob(glob_pattern)
        for file in file_list:
            input = open(file)
            lynx_parse.parse_lynx_file(bms, input)
            child=bms.dump_xbel(doc)
            xbel.appendChild(child)        
    elif type == 'raw':
        try:
            f = urllib.urlopen(url[0])
            xbel = doc.createElementNS(XBEL_NS,'xbel')
            import re
            url_list = re.split('[\n]', data)
            for url in url_list:
                if url == '':
                    continue
                bk = doc.createElementNS(XBELL_NS,'bookmark')
                title = doc.createElementNS(XBEL_NS,'title')
                title.appendChild(doc.createTextNode(url))
                bk.appendChild(title)
                bk.setAttributeNS(NO_NS,'href', url)
                xbel.appendChild(bk)     
        except IOError, e:
            return {'error': error(doc, 'No such url %s'%url[0], str(e))}
    else:
        return {'error': error(doc, 'browser type unknown : %s'% type)}
    return {'xbel':xbel}

MOD_XML=MOD_XML+'''
<al:action name='parse_bmf' func='parse_bmf_f'>
 <al:description lang="en">
parse bookmark file from several formats and transform it in an xbel elment
 </al:description>
 <al:input id='bmf' >
   <al:match>bookmark-file[@type and not(@type="xbel")]/text()</al:match>
   <al:description lang="en">url of the original bookmark file</al:description>
 </al:input>
 <al:output id='xbel' >
   <al:match>xbel</al:match>
   <al:description lang="en">the xbel bookmarks tree</al:description>
 </al:output>
</al:action>
''' 

def update_bmf_f(args, doc):
    """
    Update the $NARVAL_HOME/data/bookmarks.xbel file 
    """
    data = args['bmf'].firstChild.data
    sourceXbel = args['xbel']
    
    try:
        refXbel=read_domtree_from_uri(data)
    except:
        write_domtree_to_file(sourceXbel,data)
        return {'xbel':sourceXbel}

    sourceElementList=sourceXbel.childNodes
    # Browse the "new" xbel file
    for sourceElement in sourceXbel.childNodes:
        nodeName=sourceElement.nodeName
        # Call the appropriate function
        if nodeName == 'bookmark':
            _update_bookmark_element(sourceElement,refXbel.documentElement)
        elif nodeName == 'folder':
            _update_folder_element(sourceElement,refXbel.documentElement)
    write_domtree_to_file(sourceXbel,data)
    return {'xbel':sourceXbel}
    

MOD_XML=MOD_XML+'''
<al:action name='update_bmf' func='update_bmf_f'>
<al:description lang="en">update checksum for the xbel bookmarks pages and update
the xbel bookmarks file. Return the old xbel tree</al:description>
<al:input id='bmf' ><al:match>bookmark-file[@type="xbel"]/text()</al:match>
<al:description lang="en">the xbel bookmarks to update</al:description></al:input>
<al:input id='xbel' ><al:match>xbel</al:match>
<al:description lang="en">the new xbel bookmarks to update</al:description></al:input>
<al:output id='xbel' ><al:match>xbel</al:match>
<al:description lang="en">the original xbel tree</al:description></al:output>
</al:action>
'''

MOD_XML=MOD_XML+'</module>'


# Update a bookmark element
def _update_bookmark_element(source,refXbel):
    # retrieve the url 
    adr=source.getAttributeNS(XBEL_NS,'href')
    # try to find it in the old file
    refBms=select_many(refXbel,'//bookmark[@href="%s"]'%adr)
    # if more than one was found, then take (arbitrary) the first one
    if refBms:
        chks=refBms[0].getAttributeNS(CHKS_NS, 'checksum')
        source.removeAttributeNS(CHKS_NS, 'checksum')
        source.setAttributeNS(CHKS_NS, 'n:checksum', chks)
    #else, nothing to be done

#Update a folder element
def _update_folder_element(source,refXbel):
    sourceElementList = source.childNodes
    # Browse all the folder childs
    for sourceElement in sourceElementList:
        nodeName=sourceElement.nodeName
        # Call the appropriate function
        if nodeName == 'bookmark':
            _update_bookmark_element(sourceElement,refXbel)
        elif nodeName == 'folder':
            _update_folder_element(sourceElement,refXbel)


    

if __name__ == "__main__" :
    from xml.dom.ext.reader import Sax2
    print MOD_XML
    doc=Sax2.FromXml(MOD_XML)
    print doc.documentElement
