<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'
xmlns:n='http://www.logilab.org/narval'>

<xsl:strip-space elements='*'/>
<xsl:output method='xml'/>


<!-- Narval prototype ===================================================== -->

<al:prototype xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">
 <al:description lang="fr">Transforme un signet xml en data-unit</al:description>
 <al:description lang="en">Transform xml bookmark (xbel) to data-unit</al:description>
 <al:input id='input' list="yes">
  <al:match>bookmark</al:match>
<al:description lang="en">bookmarks to transforms</al:description>
 </al:input>
 <al:output id='output' list="yes">
  <al:match>data-unit</al:match>
<al:description lang="en">data-unit "ready to download" (you have to download its
data before the sort)</al:description>
 </al:output>
</al:prototype>

<!-- root ================================================================= -->
  <xsl:template match="al:arguments">
    <xsl:apply-templates select="bookmark"/>
  </xsl:template>


  <xsl:template match="bookmark">
   <xsl:element name="data-unit">
    <xsl:attribute name='oldmd5value'><xsl:value-of select="@n:checksum"/></xsl:attribute>
    <xsl:attribute name='md5checksum'><xsl:value-of select="@n:checksum"/></xsl:attribute>
    <xsl:attribute name='visited'><xsl:value-of select="@visited"/></xsl:attribute>
    <xsl:attribute name='modified'><xsl:value-of select="@modified"/></xsl:attribute>
    <xsl:attribute name='added'><xsl:value-of select="@added"/></xsl:attribute>

    <url><xsl:value-of select='@href'/></url>
    <title><xsl:value-of select="title/text()"/></title>
   </xsl:element>
  </xsl:template>

</xsl:transform>
