<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' 
xmlns:n='http://www.logilab.org/narval' version='1.0'>
<xsl:strip-space elements='*'/>
<xsl:output method='xml'/>

<!-- Narval prototype ====================================================== -->

<al:prototype xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">
<al:description lang="en">Presents the modified pages file using HTML</al:description>
<al:description lang="fr">Prsente le fichier des pages modifies au format HTML</al:description>

<al:input id='input' list='yes'><al:match>bookmark</al:match>
<al:description lang="en">bookmarks computed by Narval ('changed' attribute)
to transform</al:description></al:input> 
<al:output id='output'>
<al:match>html-file/url/text()</al:match>
<al:match>html-file/data/*</al:match> 
<al:description lang="en">html-file element</al:description>
</al:output>
</al:prototype>

<xsl:template match="al:arguments">
 <html-file>
   <url>file://$NARVAL_HOME/data/modified_pages.html</url>
   <data>
    <html>
     <head>
      <title>Web pages monitoring</title>
      <link rel="stylesheet" type="text/css" href="/style.css"/>
     </head>
     <body>
      <ul>
     <xsl:apply-templates select="//bookmark[@n:changed='yes']"/>
      </ul>
     </body> 
    </html>
  </data>
 </html-file>
</xsl:template>


<!--
<xsl:template match='//xbel'>
<h1>Pages modified since last check</h1>
<ul>
<xsl:apply-templates select="folder[.//bookmark[@n:changed='yes']]"/>
<xsl:apply-templates select="bookmark[@n:changed='yes']"/>
</ul>
</xsl:template>
<xsl:template match='folder'>
<li><h2><xsl:value-of select='title'/></h2>
<ul>
<xsl:apply-templates select="folder[.//bookmark[@n:changed='yes']]"/>
<xsl:apply-templates select='bookmark[@n:changed="yes"]'/>
</ul>
</li>
</xsl:template>
-->

<xsl:template match='bookmark'>
<li><a href="{@href}"><xsl:value-of select='title/text()'/>
</a></li>
</xsl:template>

</xsl:transform>
