<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'
 xmlns:n='http://www.logilab.org/narval'>

<xsl:strip-space elements='*'/>
<xsl:output method='xml'/>


<!-- Narval prototype ===================================================== -->

<al:prototype xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">
 <al:description lang="fr">Transforme un bookmarks xml (xbel) en plusieurs data-unit</al:description>
 <al:description lang="en">Transform xml bookmarks (xbel) to data-unit</al:description>
 <al:output id='inserted-node'>
  <al:match>xbel</al:match>
<al:description lang="en">new xbel element</al:description>
 </al:output>
 <al:input id='input' list='yes'>
  <al:match>data-unit</al:match>
<al:description lang="en">data-units obtained from xbel element</al:description>
 </al:input>
</al:prototype>

<!-- root ================================================================= -->
 <xsl:template match="al:arguments">
<xsl:message>XEBL</xsl:message>
 <xbel xmlns:n='http://www.logilab.org/narval'>
    <xsl:apply-templates select="data-unit"/>
 </xbel>
 </xsl:template>


  <xsl:template match="data-unit">
   <xsl:element name='bookmark'>
<xsl:message><xsl:value-of select='url/text()'/></xsl:message>
    <xsl:attribute name='href'><xsl:value-of select='url/text()'/></xsl:attribute>
    <xsl:attribute name='n:checksum'><xsl:value-of select="@md5checksum"/></xsl:attribute>
    <xsl:attribute name='n:changed'>
     <xsl:choose>
      <xsl:when test="@md5checksum=@oldmd5value">no</xsl:when>
      <xsl:otherwise>yes</xsl:otherwise>
     </xsl:choose>
    </xsl:attribute>
    <xsl:attribute name='visited'><xsl:value-of select="@visited"/></xsl:attribute>
    <xsl:attribute name='modified'><xsl:value-of select="@modified"/></xsl:attribute>
    <xsl:attribute name='added'><xsl:value-of select="@added"/></xsl:attribute>
    <title><xsl:value-of select="title/text()"/></title>
   </xsl:element>
  </xsl:template>

</xsl:transform>
