<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'>

<xsl:strip-space elements='*'/>
<xsl:output method='xml'/>


<!-- Narval prototype ===================================================== -->

<al:prototype xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">
 <al:description lang="fr">Transforme plusieurs sort-group en un xbel </al:description>
 <al:description lang="en">Transform sort-group to xml bookmarks (xbel)</al:description>
 <al:input id='input' list="yes">
  <al:match>sort-group</al:match>
<al:description lang="en">sort groups produced from data-unit / bookmarks elements
</al:description>
 </al:input>
 <al:output id='output'>
  <al:match>xbel</al:match>
<al:description lang="en">xbel formatted bookmarks</al:description>
 </al:output>
</al:prototype>

<!-- root ================================================================= -->
  <xsl:template match="al:arguments">
  <xbel>
    <xsl:apply-templates select="sort-group"/>
  </xbel>
  </xsl:template>


  <xsl:template match="sort-group">
  <folder>
    <title><xsl:value-of select="common/text()"/></title>
    <xsl:apply-templates select="data-unit"/>
  </folder>
  </xsl:template>

  <xsl:template match="data-unit">
  <bookmark>
  <xsl:attribute name="href"><xsl:value-of select="url"/></xsl:attribute>
  <title><xsl:value-of select="title/text()"/></title>
  </bookmark>
  </xsl:template>

</xsl:transform>
