<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'>

<xsl:strip-space elements='*'/>
<xsl:output method='xml'/>


<!-- Narval prototype ===================================================== -->

<al:prototype xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">
 <al:description lang="fr">Transforme un bookmarks xml (xbel) en html-file</al:description>
 <al:description lang="en">Transform xml bookmarks (xbel) to html-file</al:description>

 <al:input id='xbel'>
  <al:match>xbel</al:match>
<al:description lang="en">xbel bookmarks to transforms</al:description>
 </al:input>
 <al:input id='url'>
  <al:match>url/text()</al:match>
<al:description lang="en">url for the html file</al:description>
 </al:input>
 <al:output id='output'>
  <al:match>html-file/url/text()</al:match>
  <al:match>html-file/data/*</al:match>
<al:description lang="en">html-file element</al:description>
 </al:output>
</al:prototype>

<!-- root ================================================================= -->
  <xsl:template match="al:arguments">
   <html-file>
    <url><xsl:value-of select="url/text()"/>
    </url>
    <data>

      <html>
       <head>
        <title>Sorted Bookmarks</title>
        <link rel="stylesheet" type="text/css" href="style.css"/>
       </head>
       <body bgcolor='#ffffff' text='#000000'>
        <xsl:apply-templates select="xbel"/>
       </body>
      </html>
    </data>
   </html-file>

  </xsl:template>


  <xsl:template match="xbel">
    <h1>Sorted Bookmarks</h1>
    <xsl:apply-templates select="desc"/>
    <br/><br/>
    <xsl:apply-templates select="folder"/>
    <xsl:apply-templates select="bookmark"/>
  </xsl:template>


  <xsl:template match="folder">
    <li>
      <h2>
        <xsl:apply-templates select="title"/>
      </h2>
      <ul>
        <xsl:apply-templates select="bookmark"/>
      </ul>
    </li>
  </xsl:template>


  <xsl:template match="bookmark">
    <li>
      <a href='{@href}'>
        <xsl:apply-templates select="title"/>
      </a><xsl:apply-templates select="desc"/>
    </li>
  </xsl:template>


  <xsl:template match="desc">
    <xsl:value-of select="./text()"/>
  </xsl:template>


  <xsl:template match="title">
    <xsl:value-of select="./text()"/>
  </xsl:template>

</xsl:transform>
