<?xml version="1.0" encoding="ISO-8859-1"?>

  <xsl:transform version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">

    <xsl:output method='xml' indent='yes' encoding='ISO-8859-1' version='1.0'/>
    <xsl:strip-space elements='*'/>


    <al:prototype>
      <al:description lang='fr'>Construction d'une rss  partir de la
page html de Linux Weekly News.</al:description>
      <al:description lang='en'>Extract rss definition from the linux
weekly news web page</al:description>

      <al:input id='input'>
        <al:match>xhtml</al:match>
	<al:description lang="en">xhtml formatted element extracted from the
      Linux Weekly News web page</al:description>
      </al:input>

      <al:output id='output' >
        <al:match>rss</al:match>
	<al:description lang="en">rss element</al:description>
      </al:output>
    </al:prototype>


    <xsl:template match='xhtml'>
     <rss>    
      <channel>
      <title>
        <xsl:value-of select='head/title/text()'/>, processed by Narval 
      </title> 
      <link>http://lwn.net/daily/</link>
      <description>RSS source extracted from Linux Weekly News web page</description>
      <xsl:apply-templates select='(body/table)[position() = last()]/tr/td[2]/table/tr[(position() - 1) mod 4 = 0]'/>
      </channel>
     </rss>      
    </xsl:template> 


    <xsl:template match='tr'>
     <item>
      <title>
        <xsl:value-of select='th/a/text()'/>
      </title> 
      <description>      
        <xsl:apply-templates select='following-sibling::tr[1]/td'/>

        <xsl:apply-templates select='following-sibling::tr[2]/td'/>
      </description> 
      <link>
        <xsl:value-of select='following-sibling::tr[2]/td/a/@href/text()'/>
      </link> 
     </item>
    </xsl:template>
  </xsl:transform>
