<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'>

<xsl:strip-space elements='*'/>
<xsl:output method='xml'/>

<!-- Narval prototype ====================================================== -->

<al:prototype xmlns:al="http://www.logilab.org/namespaces/Narval/1.2">
<al:description lang="fr">Produit le journal  partir de sort-group enrichi.</al:description>
<al:description lang="en">Merge enriched sort-group into a newspaper.</al:description>
<al:input id='input'  list='yes'><al:match>sort-group</al:match>
<al:description lang="en">sort groups produced from data-unit / rss elements</al:description></al:input>
<al:output id='output' ><al:match>xhtml</al:match>
<al:description lang="en">xhtml newspaper</al:description></al:output>
</al:prototype>

<!-- root ================================================================== -->

<xsl:template match='al:arguments'>
  <xhtml>     
  <head>
  <link href='style.css' rel='stylesheet' type='text/css'/>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
  <meta name="Description" content="Narval\'s Journal"/>
  <meta name="Generator" content="Narval"/>
  <title>Internet Morning News</title>
  </head>
  <body><h1>Internet Morning News</h1>

  <xsl:apply-templates select='sort-group'/>

  </body>
  </xhtml>
</xsl:template>
 
<xsl:template match='sort-group'>
  <h2>
    <xsl:value-of select='common'/>
  </h2>
  <table border="1" width="90%">
    <xsl:apply-templates select='data-unit'/>
  </table>
  <hr/>
</xsl:template>

<xsl:template match='data-unit'>
    <tr>
      <td>
        <xsl:element name='a'>
          <xsl:attribute name='href'><xsl:value-of select='url'/></xsl:attribute>
          <xsl:value-of select='title'/>
        </xsl:element>
      </td>
      <td>
        <xsl:value-of select='description/text()'/>
      </td>
      <td>
        <xsl:value-of select='channel-title/text()'/>
      </td>
    </tr>
</xsl:template>

</xsl:transform>
